#include "FileHandler.h"



FileHandler::FileHandler(String^ InPutDir, String^ OutputDir)
{
	this->FileList = gcnew Collections::Generic::List<String^>();
	this->Directory = gcnew Collections::Generic::Stack<String^>();
	this->in = InPutDir;
	this->Directory->Push(this->in);
	this->out = OutputDir;
}
void FileHandler::StartExplore()
{
	while (this->Directory->Count>0)
	{
		this->Explore();
	}
	this->Directory->Push(this->in);
}
void FileHandler::Explore()
{

	
	Collections::Generic::IEnumerable<System::String^>^ Files = IO::Directory::EnumerateFiles(this->Directory->Peek());
	

	for each (String ^ currentfile in Files)
	{

		array<String^>^ currentdirArray = currentfile->Split('.');
		String^ format = currentdirArray[currentdirArray->Length - 1];

		if (format->Equals("jpg") || format->Equals("png") || format->Equals("mp4") || format->Equals("mov") || format->Equals("avi") || format->Equals("wmv"))
		{

			this->FileList->Add(currentfile);
			
		}
		
	}

	Collections::Generic::IEnumerable<System::String^>^ dir = IO::Directory::EnumerateDirectories(this->Directory->Pop());

	for each (String ^ currentdir in dir)
	{
			
		this->Directory->Push(currentdir);
		
	}
}
void FileHandler::CrateTxt()
{
	for each (String ^ curentFile in this->FileList)
	{
		Console::WriteLine(curentFile);
	}

}
void  FileHandler::CopyFiles(bool Erase,System::ComponentModel::BackgroundWorker^ bw)
{
	
	String^ Copydir = this->out + "\\" + System::DateTime::Now.ToString("dd-MM-yyyy") +"\\";
	Collections::Generic::List<String^>^ LastFileName = gcnew Collections::Generic::List<String^>();
	int maxi = this->FileList->Count;

	
	for (int i = 0; i < this->FileList->Count; i++)
	{
		
		
		array<String^>^ file = this->FileList[i]->Split('\\');
		String^ filename = file[file->Length - 1];

		String^ Finaldir = this->GetCorrectDir(this->FileList[i]);
		
		

		this->CreateDirectory(Copydir + Finaldir);
		if(LastFileName->IndexOf(filename) == -1 )
		{
			System::IO::File::Copy(this->FileList[i], Copydir + Finaldir + filename,true);
		}
		else
		{
			Finaldir = "Copy\\";
			Finaldir += this->GetCorrectDir(this->FileList[i]);

			this->CreateDirectory(Copydir + Finaldir);
			System::IO::File::Copy(this->FileList[i], Copydir + Finaldir + "Copy" + i.ToString() +filename ,true);
		}

		if (Erase)
		{
			System::IO::File::Delete(this->FileList[i]);
		}
		
		LastFileName->Add(filename);
		
		float curent = (((float)i + 1.0f) / (float)maxi)*100.0f;
		bw->ReportProgress(curent, "coping '" + this->FileList[i] + "'");

		
	}
	

}

void FileHandler::CreateDirectory(String^ dirName)
{
	if (!IO::Directory::Exists(dirName))
	{
		IO::Directory::CreateDirectory(dirName);
	}
}

String^ FileHandler::GetCorrectDir(String^ filedir)
{
	String^ r = "";
	array<String^>^ file = filedir->Split('\\');
	String^ filename = file[file->Length - 1];

	array<String^>^ filenamearray = filename->Split('.');
	String^ filleFormat = filenamearray[filenamearray->Length - 1];


	if (filleFormat->Equals("jpg") || filleFormat->Equals("png"))
	{
		r += "Images\\";
	}
	else if (filleFormat->Equals("mp4") || filleFormat->Equals("mov") || filleFormat->Equals("avi") || filleFormat->Equals("wmv"))
	{
		r += "Video\\";
	}
	else
	{
		r += "others\\";
	}


	String^ test = "";
	if (array<String^>::IndexOf(file,"WhatsApp") != -1)
	{
		r += "WhatsApp\\";
	}
	
	array<String^>^ filenamedata = filename->Split('-');
	if (filenamedata->Length == 3 && filenamedata[1]->Length == 8)
	{
		r += filenamedata[1]->Substring(0, 4) + "\\";
		r += filenamedata[1]->Substring(4, 2) + "\\";
	}
	else
	{
		r += "others\\";
	}
	


	return r;

}
